Index: css/docuviewer.css
===================================================================
--- css/docuviewer.css	(revision 533)
+++ css/docuviewer.css	(revision 535)
@@ -31,7 +31,10 @@
 div.page-head div.title {
     max-width: 50em;
-    border: 1px solid silver;
+    background-color: white;
+	font-family: Georgia,Times,serif;
+	font-size: 14px;
+	line-height: 1.3;
+	border: 1px solid silver;
     padding: 0.5em;  
-    background-color: white;
 }
 
@@ -70,11 +73,14 @@
 }
 
+div.toc-switcher-col {
+	display: table-cell;
+}
 div.toc-switcher {
-    display: table-cell;
+    display: block; /* moz only does relative with block */
+    position: relative;
     width: 26.5px; /* for moz and webkit -- don't ask me */
 }
 div.toc-switcher ul {
     position: absolute;
-    /* z-index: 20; */
     transform: rotate(270deg);
     transform-origin: top left;
@@ -85,8 +91,10 @@
     -o-transform: rotate(270deg);
     -o-transform-origin: top left;
-    left: 12px;
-    top: 486px;
+	left: 7px;
+    top: 32em;
+    width: 40em;
     padding: 0px;
 }
+
 div.toc-switcher li {
     list-style-type: none;
@@ -105,5 +113,4 @@
 
 div.tocbody {
-    /* z-index: 10; */
     display: table-cell;
     border: 1px solid silver;
@@ -138,5 +145,5 @@
 div.tocbody table.thumbs .thumbsel {
     padding: 2px;
-    border: 1px solid blue;
+    border: 1px solid #892B06;
 }
 div.tocbody table.thumbs .thumbcap {
@@ -164,9 +171,11 @@
 
 div.col.main div.content {
-    border: 1px solid silver;
-    padding: 1em;  
-    background-color: white;
+	min-width: 30em;
+    background-color: white;
+    font-family: Junicode,Gentium,Georgia,serif;
     font-size: 14px;
-    font-family: Junicode,Gentium,Georgia,serif;
+	line-height: 1.3;
+	border: 1px solid silver;
+    padding: 1em;
 }
 div.col.main div.content a:link,
@@ -183,7 +192,9 @@
  */
 div.col.buttons div.options {
-    border: 1px solid silver;
-    padding: 0.5em;  
-    background-color: white;    
+    background-color: white;
+	border: 1px solid silver;
+    border-radius: 5px;
+    padding: 0.5em;
+    margin-bottom: 5px;  
 }
 div.col.buttons h4 {
@@ -205,2 +216,14 @@
 }
 
+/*
+ * index page
+ */
+div.index-image {
+	float: left;
+	padding-left: 1em;
+	padding-right: 1em;
+	padding-bottom: 1em;
+}
+div.index-info td.type {
+	font-weight: bold;
+}
Index: css/docuviewer_ie.css
===================================================================
--- css/docuviewer_ie.css	(revision 535)
+++ css/docuviewer_ie.css	(revision 535)
@@ -0,0 +1,10 @@
+/* fix rotated text positioning */
+div.toc-switcher ul {
+    filter: progid:DXImageTransform.Microsoft.BasicImage(rotation=3);
+    left: 5px;
+    top: -8em;
+    height: 26px;
+    width: 40em;
+    padding-top: 3px;
+    z-index: 10;
+}
Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 532)
+++ documentViewer.py	(revision 535)
@@ -146,4 +146,7 @@
     # make docuviewer_css refreshable for development
     docuviewer_css.index_html = refreshingImageFileIndexHtml
+    docuviewer_ie_css = ImageFile('css/docuviewer_ie.css',globals())
+    # make docuviewer_ie_css refreshable for development
+    docuviewer_ie_css.index_html = refreshingImageFileIndexHtml
     jquery_js = ImageFile('js/jquery.js',globals())
     
Index: version.txt
===================================================================
--- version.txt	(revision 518)
+++ version.txt	(revision 535)
@@ -1,1 +1,1 @@
-DocumentViewer 2.1.2a
+DocumentViewer 2.2.0
Index: zpt/common_template.zpt
===================================================================
--- zpt/common_template.zpt	(revision 534)
+++ zpt/common_template.zpt	(revision 535)
@@ -101,4 +101,5 @@
   <!-- toc type switcher -->
   <metal:block metal:define-macro="toc_switcher">
+  <div class="toc-switcher-col">
     <div class="toc-switcher">
       <ul>
@@ -118,4 +119,5 @@
       </ul>
     </div>
+    </div>
   </metal:block>
 
Index: zpt/toc_concordance.zpt
===================================================================
--- zpt/toc_concordance.zpt	(revision 532)
+++ zpt/toc_concordance.zpt	(revision 535)
@@ -13,5 +13,4 @@
                 pageNumbers docinfo/pageNumbers | nothing;
                 batch python:here.getBatch(start=start,size=grpsize,end=tocsize,data=pageNumbers);">
-      <div metal:use-macro="here/template/common_template/macros/toc_switcher" />
       <div class="ruler">
         <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
Index: zpt/toc_figures.zpt
===================================================================
--- zpt/toc_figures.zpt	(revision 532)
+++ zpt/toc_figures.zpt	(revision 535)
@@ -12,5 +12,4 @@
       tal:define="start pageinfo/start; tocsize docinfo/numFigureEntries; grpsize pageinfo/tocPageSize;
                 batch python:here.getBatch(start=start,size=grpsize,end=tocsize);">
-      <div metal:use-macro="here/template/common_template/macros/toc_switcher" />
       <div class="ruler">
         <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
Index: zpt/toc_none.zpt
===================================================================
--- zpt/toc_none.zpt	(revision 526)
+++ zpt/toc_none.zpt	(revision 535)
@@ -9,5 +9,5 @@
   <div class="toc-none" metal:define-macro="main">
     <div metal:use-macro="here/template/common_template/macros/toc_switcher"/>
-    <div class="content"></div>
+    <!--  <div class="tocbody none"></div> -->
   </div>
   <!-- toc -->
Index: zpt/viewer_index.zpt
===================================================================
--- zpt/viewer_index.zpt	(revision 505)
+++ zpt/viewer_index.zpt	(revision 535)
@@ -18,8 +18,8 @@
     <!-- image -->
     <a tal:define="tp docinfo/titlePage | nothing"
-      tal:attributes="href python:context.getLink('viewMode','auto')"><img
+      tal:attributes="href python:context.getLink(params={'viewMode':'auto','pn':tp})"><img
       tal:condition="tp" border="0"
       tal:attributes="src string:${docinfo/imageURL}&pn=$tp&dw=300&dh=500" /><img
-      tal:condition="not:tp" border="0" src="images/oldbook.png" /></a>
+      tal:condition="python:not tp and exists('here/template/book.png')" border="0" src="template/book.png" /></a>
   </div>
 
Index: zpt/viewer_text.zpt
===================================================================
--- zpt/viewer_text.zpt	(revision 532)
+++ zpt/viewer_text.zpt	(revision 535)
@@ -12,4 +12,5 @@
 <title tal:content="python:docinfo.get('creator',' ') + ' - ' + docinfo.get('title',' ')" />
 <link rel="stylesheet" href="template/docuviewer_css" type="text/css" />
+<!--[if IE]><link rel="stylesheet" href="template/docuviewer_ie_css" type="text/css" /><![endif]-->
 <script type="text/javascript" tal:attributes="src string:$rootUrl/template/jquery_js"></script>
 <script type="text/javascript">