Index: zpt/layer_text_dict.zpt
===================================================================
--- zpt/layer_text_dict.zpt	(revision 526)
+++ zpt/layer_text_dict.zpt	(revision 537)
@@ -24,17 +24,18 @@
   <metal:block metal:define-macro="options_box" tal:condition="python:'dict' in viewLayers">
     <!--"BEGIN DICTIONARY OVERVIEW"-->
-    <div class="options">
+    <!-- <div class="options">
       <h4>Dictionary view</h4>
       <form name="f3" action="">
+      <div>Open dictionary definition</div>
         <ul>
           <li>
-            <input type="radio" name="r3" /> Tab
+            <input type="radio" name="r3" /> in new Tab
           </li>
           <li>
-            <input type="radio" name="r3" /> Window
+            <input type="radio" name="r3" /> in new Window
           </li>
         </ul>
       </form>
-    </div>
+    </div> -->
     <!--"END DICTIONARY OVERVIEW"-->
   </metal:block>
Index: zpt/toc_concordance.zpt
===================================================================
--- zpt/toc_concordance.zpt	(revision 535)
+++ zpt/toc_concordance.zpt	(revision 537)
@@ -13,9 +13,10 @@
                 pageNumbers docinfo/pageNumbers | nothing;
                 batch python:here.getBatch(start=start,size=grpsize,end=tocsize,data=pageNumbers);">
+      <h4>Page concordance</h4>              
       <div class="ruler">
         <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
       </div>
       <div class="content">
-        <table tal:condition="pageNumbers">
+        <table class="concordance" tal:condition="pageNumbers">
           <tr>
             <th>Scan</th>
Index: zpt/toc_figures.zpt
===================================================================
--- zpt/toc_figures.zpt	(revision 535)
+++ zpt/toc_figures.zpt	(revision 537)
@@ -12,4 +12,5 @@
       tal:define="start pageinfo/start; tocsize docinfo/numFigureEntries; grpsize pageinfo/tocPageSize;
                 batch python:here.getBatch(start=start,size=grpsize,end=tocsize);">
+      <h4>Table of figures</h4>
       <div class="ruler">
         <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
Index: zpt/toc_text.zpt
===================================================================
--- zpt/toc_text.zpt	(revision 532)
+++ zpt/toc_text.zpt	(revision 537)
@@ -6,10 +6,11 @@
 </head>
 <body>
-  <div class="toc-container" metal:define-macro="main">
+  <div class="toc-container" metal:define-macro="main"
+    tal:define="start pageinfo/start; tocsize docinfo/numTocEntries; grpsize pageinfo/tocPageSize;
+                batch python:here.getBatch(start=start,size=grpsize,end=tocsize);">
     <div metal:use-macro="here/template/common_template/macros/toc_switcher" />
     <!-- block used for main content area -->
-    <div class="tocbody text"
-      tal:define="start pageinfo/start; tocsize docinfo/numTocEntries; grpsize pageinfo/tocPageSize;
-                batch python:here.getBatch(start=start,size=grpsize,end=tocsize);">
+    <div class="tocbody text">
+      <h4>Table of contents</h4>
       <div class="ruler">
         <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
@@ -18,5 +19,5 @@
     </div>
   </div>
-    <!-- toc -->
+  <!-- toc -->
 </body>
 </html>
Index: zpt/toc_thumbs.zpt
===================================================================
--- zpt/toc_thumbs.zpt	(revision 534)
+++ zpt/toc_thumbs.zpt	(revision 537)
@@ -19,8 +19,8 @@
 
       <div class="content">
+        <h4>List of thumbnails</h4>
         <div class="ruler">
           <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler_thumbs" />
         </div>
-
         <table class="thumbs">
           <tr tal:repeat="row pageBatch/pages">
Index: zpt/viewer_index.zpt
===================================================================
--- zpt/viewer_index.zpt	(revision 536)
+++ zpt/viewer_index.zpt	(revision 537)
@@ -77,8 +77,8 @@
   <div class="index-actions">
     <div class="action">
-      <a class="openbutton" tal:attributes="href python:context.getLink('viewMode','auto')">&#8594;Access Book</a>
+      <a class="openbutton" tal:attributes="href python:context.getLink('viewMode','auto')">&#8594;Browse document</a>
     </div>
     <div class="action" tal:condition="docpath">
-      Download as <a
+      Download full document as <a
         tal:attributes="href python:'http://mpdl-system.mpiwg-berlin.mpg.de/mpdl/getDoc?doc=%s'%(docpath.replace('.xml','.html'))"
         target="_blank">&#8594;HTML</a> or <a