Index: zpt/layer_image_ocrsearch.zpt
===================================================================
--- zpt/layer_image_ocrsearch.zpt	(revision 592)
+++ 	(revision )
@@ -1,52 +1,0 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
-          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml">
-<head>
-<metal:block metal:define-macro="html_head" tal:define="global query pageinfo/query | nothing;" 
-  tal:condition="python:('ocrsearch' in viewLayers) and query">
-  <!--  ocrsearch for digilib -->
-  <script type="text/javascript" tal:attributes="src string:$dlBaseUrl/jquery/showdown.js"></script>
-  <script type="text/javascript" tal:attributes="src string:$dlBaseUrl/jquery/annotator-dl.js"></script>
-  <script type="text/javascript" tal:attributes="src string:$dlBaseUrl/jquery/jquery.digilib.annotator.js"></script>
-  <link rel="stylesheet" type="text/css" tal:attributes="href string:$dlBaseUrl/jquery/annotator.min.css"/>
-
-  <script type="text/javascript" 
-    tal:define="global annServerUrl string:http://md.mpiwg-berlin.mpg.de/searchLines;
-    annUri docinfo/documentPath;
-    annPf pageinfo/pf | nothing;"
-    tal:content="structure string:
-    dlOpts.digilibFrontendPath='/jquery/digilib-ann.html';
-    dlOpts.annotationServerUrl='$annServerUrl/annotator';
-    dlOpts.annotationsReadOnly=true;
-    dlOpts.annotatorPlugins=['Store','Markdown','DigilibIntegrator'];
-    dlOpts.annotatorPluginSettings={'Store':{'loadFromSearch':{'uri':'$annUri','pf':'$annPf','query':'$query'}}};
-    "></script>
-</metal:block>
-
-</head>
-<body>
-  <!-- right-side options -->
-  <div class="col buttons">
-    <!-- LAYER DISPLAY OPTION  -->
-    <ul>
-      <li metal:define-macro="layer_select_li" tal:condition="query">
-        <input type="checkbox" class="autosubmit" name="viewLayer" value="ocrsearch"
-          tal:attributes="checked python:'ocrsearch' in viewLayers" /> Search results
-      </li>
-    </ul>
-  </div>
-
-  <metal:block metal:define-macro="options_box" tal:condition="python:('ocrsearch' in viewLayers) and query">
-    <!-- BEGIN OCRSEARCH -->
-    <div class="options">
-      <h4>OCR Search</h4>
-      <p>
-        Query: "<span tal:replace="query"/>".
-      </p>
-    </div>
-    <!-- END OCRSEARCH -->
-  </metal:block>
-
-</body>
-
-</html>
Index: zpt/layer_image_search.zpt
===================================================================
--- zpt/layer_image_search.zpt	(revision 593)
+++ zpt/layer_image_search.zpt	(revision 593)
@@ -0,0 +1,52 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
+          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<metal:block metal:define-macro="html_head" tal:define="global query pageinfo/query | nothing;" 
+  tal:condition="python:('search' in viewLayers) and query">
+  <!--  search for digilib -->
+  <script type="text/javascript" tal:attributes="src string:$dlBaseUrl/jquery/showdown.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$dlBaseUrl/jquery/annotator-dl.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$dlBaseUrl/jquery/jquery.digilib.annotator.js"></script>
+  <link rel="stylesheet" type="text/css" tal:attributes="href string:$dlBaseUrl/jquery/annotator.min.css"/>
+
+  <script type="text/javascript" 
+    tal:define="global annServerUrl string:http://md.mpiwg-berlin.mpg.de/searchLines;
+    annUri docinfo/documentPath;
+    annPf pageinfo/pf | nothing;"
+    tal:content="structure string:
+    dlOpts.digilibFrontendPath='/jquery/digilib-ann.html';
+    dlOpts.annotationServerUrl='$annServerUrl/annotator';
+    dlOpts.annotationsReadOnly=true;
+    dlOpts.annotatorPlugins=['Store','Markdown','DigilibIntegrator'];
+    dlOpts.annotatorPluginSettings={'Store':{'loadFromSearch':{'uri':'$annUri','pf':'$annPf','query':'$query'}}};
+    "></script>
+</metal:block>
+
+</head>
+<body>
+  <!-- right-side options -->
+  <div class="col buttons">
+    <!-- LAYER DISPLAY OPTION  -->
+    <ul>
+      <li metal:define-macro="layer_select_li" tal:condition="query">
+        <input type="checkbox" class="autosubmit" name="viewLayer" value="search"
+          tal:attributes="checked python:'search' in viewLayers" /> Search results
+      </li>
+    </ul>
+  </div>
+
+  <metal:block metal:define-macro="options_box" tal:condition="python:('search' in viewLayers) and query">
+    <!-- BEGIN OCRSEARCH -->
+    <div class="options">
+      <h4>OCR Search</h4>
+      <p>
+        Query: "<span tal:replace="query"/>".
+      </p>
+    </div>
+    <!-- END OCRSEARCH -->
+  </metal:block>
+
+</body>
+
+</html>