Index: zpt/viewer/layer_text_annotator.zpt
===================================================================
--- zpt/viewer/layer_text_annotator.zpt	(revision 594)
+++ zpt/viewer/layer_text_annotator.zpt	(revision 600)
@@ -8,25 +8,20 @@
     tal:attributes="href string:$rootUrl/template/annotator_files/css/annotator.css" />
 
-  <script
-    tal:attributes="src string:$rootUrl/template/annotator_files/lib/vendor/json2.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/extensions.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/console.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/class.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/range.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/annotator.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/widget.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/editor.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/viewer.js"></script>
-  <script
-    tal:attributes="src string:$rootUrl/template/annotator_files/lib/notification.js"></script>
-  <script
-    tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/store.js"></script>
-  <script
-    tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/permissions.js"></script>
-  <!-- <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/annotateitpermissions.js"></script> -->
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/auth.js"></script>
-  <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/tags.js"></script>
-  <script
-    tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/unsupported.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/vendor/json2.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/vendor/showdown.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/extensions.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/console.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/class.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/range.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/annotator.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/widget.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/editor.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/viewer.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/notification.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/store.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/permissions.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/auth.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/tags.js"></script>
+  <script type="text/javascript" tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/unsupported.js"></script>
   <!-- <script tal:attributes="src string:$rootUrl/template/annotator_files/lib/plugin/filter.js"></script> -->
 
@@ -83,6 +78,5 @@
                         'uri' : uri
                     }
-                }).addPlugin('Tags'
-                );
+                }).addPlugin('Tags').addPlugin('Markdown');
             });
         // -->