Index: MpiwgXmlTextServer.py
===================================================================
--- MpiwgXmlTextServer.py	(revision 587)
+++ MpiwgXmlTextServer.py	(revision 609)
@@ -96,7 +96,10 @@
         
         field = ''
-        if mode in ['pages', 'toc', 'figures', 'handwritten']:
+        if mode in ['pages', 'toc', 'figures', 'notes', 'handwritten']:
             # translate mode to field param
-            field = '&field=%s'%mode
+            if mode == 'handwritten':
+                field = '&field=notesHandwritten'
+            else:
+                field = '&field=%s'%mode
         else:
             mode = None
@@ -132,5 +135,7 @@
                     docinfo['numTextPages'] = getInt(getText(sys.find('countPages'))) 
                     docinfo['numFigureEntries'] = getInt(getText(sys.find('countFigures'))) 
-                    docinfo['numHandwritten'] = getInt(getText(sys.find('countHandwritten'))) 
+                    docinfo['numHandwritten'] = getInt(getText(sys.find('countNotesHandwritten'))) 
+                    docinfo['numNotes'] = getInt(getText(sys.find('countNotes'))) 
+                    docinfo['numPlaces'] = getInt(getText(sys.find('countPlaces'))) 
                     docinfo['numTocEntries'] = getInt(getText(sys.find('countTocEntries'))) 
                     
@@ -162,5 +167,5 @@
                                     
                     # toc
-                    elif lt == 'toc' or lt == 'figures' or lt == 'handwritten':
+                    elif lt in ['toc', 'figures', 'notes', 'notesHandwritten']:
                         # contains tags with table of contents/figures
                         # <item n="2.1." lv="2">CAP.I. <ref o="119">132</ref></item>
@@ -661,13 +666,16 @@
         tocs = fulltoc[first:last]
         tp = '<div>'
-        label = {'figures': 'Figure', 'handwritten': 'Handwritten note'}.get(mode, 'Item')
+        label = {'figures': 'Figure', 'notes': 'Note', 'handwritten': 'Handwritten note'}.get(mode, 'Item')
         for toc in tocs:
             pageurl = self.getLink('pn', toc['pn'])
             tp += '<div class="tocline">'
             content = toc['content']
+            lvs = toc['level-string']
             if content:
-                tp += '<div class="toc name">[%s] %s</div>'%(toc['level-string'], toc['content'])
+                tp += '<div class="toc name">[%s] %s</div>'%(lvs, toc['content'])
+            elif lvs:
+                tp += '<div class="toc name">[%s %s]</div>'%(label, lvs)
             else:
-                tp += '<div class="toc name">[%s %s]</div>'%(label, toc['level-string'])
+                tp += '<div class="toc name">[%s]</div>'%(label)
             
             if toc.get('no', None):
Index: css/docuviewer.css
===================================================================
--- css/docuviewer.css	(revision 608)
+++ css/docuviewer.css	(revision 609)
@@ -102,6 +102,6 @@
     -o-transform-origin: top left;
 	left: 7px;
-    top: 34em;
-    width: 40em;
+    top: 42em;
+    width: 45em;
     padding: 0px;
 }
Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 608)
+++ documentViewer.py	(revision 609)
@@ -120,4 +120,5 @@
     toc_figures = PageTemplateFile('zpt/viewer/toc_figures', globals())
     toc_concordance = PageTemplateFile('zpt/viewer/toc_concordance', globals())
+    toc_notes = PageTemplateFile('zpt/viewer/toc_notes', globals())
     toc_handwritten = PageTemplateFile('zpt/viewer/toc_handwritten', globals())
     toc_none = PageTemplateFile('zpt/viewer/toc_none', globals())
Index: version.txt
===================================================================
--- version.txt	(revision 607)
+++ version.txt	(revision 609)
@@ -1,1 +1,1 @@
-DocumentViewer 2.2.10
+DocumentViewer 2.2.11
Index: zpt/viewer/common_template.zpt
===================================================================
--- zpt/viewer/common_template.zpt	(revision 608)
+++ zpt/viewer/common_template.zpt	(revision 609)
@@ -116,7 +116,10 @@
             tal:condition="python:docpath and docinfo.get('pageNumbers', None)"><span><a
               tal:omit-tag="python:tocMode=='concordance'" tal:attributes="href python:here.getLink('tocMode','concordance')">Concordance</a></span></li>
+          <li tal:attributes="class python:here.getStyle(tocMode, 'notes')"
+            tal:condition="python:docpath and docinfo.get('numNotes', None)"><span><a
+              tal:omit-tag="python:tocMode=='notes'" tal:attributes="href python:here.getLink('tocMode','notes')">Notes</a></span></li>
           <li tal:attributes="class python:here.getStyle(tocMode, 'handwritten')"
             tal:condition="python:docpath and docinfo.get('numHandwritten', None)"><span><a
-              tal:omit-tag="python:tocMode=='handwritten'" tal:attributes="href python:here.getLink('tocMode','handwritten')">Notes</a></span></li>
+              tal:omit-tag="python:tocMode=='handwritten'" tal:attributes="href python:here.getLink('tocMode','handwritten')">Handwritten</a></span></li>
           <li tal:attributes="class python:here.getStyle(tocMode, 'figures')"
             tal:condition="python:docpath and docinfo.get('numFigureEntries', None)"><span><a
Index: zpt/viewer/toc_notes.zpt
===================================================================
--- zpt/viewer/toc_notes.zpt	(revision 609)
+++ zpt/viewer/toc_notes.zpt	(revision 609)
@@ -0,0 +1,27 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
+          "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+</head>
+<body>
+  <div class="toc-container" metal:define-macro="main">
+    <div metal:use-macro="here/template/common_template/macros/toc_switcher" />
+    <!-- block used for main content area -->
+    <div class="tocbody figures"
+      tal:define="start pageinfo/start; tocsize docinfo/numHandwritten; grpsize pageinfo/tocPageSize;
+                batch python:here.getBatch(start=start,size=grpsize,end=tocsize);">
+      <h4>Table of Notes</h4>
+      <div class="ruler top">
+        <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
+      </div>
+      <div class="content"
+        tal:content="structure python:here.getTocPage(mode='notes',start=start,pageinfo=pageinfo,docinfo=docinfo)" />
+      <div class="ruler bottom">
+        <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
+      </div>
+    </div>
+  </div>
+  <!-- /toc -->
+</body>
+</html>